# --*-- coding:utf-8 --*--
import sys 
import os
import re
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context


#对应excel中的属性字段
key_lst  = [
                'group_num',
                'asm_dg',
                'asm_dg_status',
                'capacity',
                'asm_disk_name',
                'asm_disk_path'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #{属性名:[对应列表]}
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    #{属性名:[对应回文的列表]}
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(key)
                break
    #检查key_lst
    keylst_match = False
    if len(key_lst) == len(attribute_arr):
        keylst_match = True
    else:
        raise Exception('key_lst not match')
    asmdg_objlst = []
    if keylst_match:
        #1
        #根据asmdg name求asmdg对象集合，发现一个名字认为有一个asmdg对象
        asm_dgnamelst = attr_valuelst_dic[attribute_arr[1]][2:-1]
        #去掉不是有效值的行
        templst = []
        for line in asm_dgnamelst:
            if ('GROUP_NUMBER'.lower() in line.lower()) or ('NAME'.lower() in line.lower()):
                continue
            elif ('---' in line):
                continue
            templst.append(line)
        asm_dgnamelst = templst
        for line in asm_dgnamelst:
            dgobj = Disk_Group()
            lst = re.split('\\s+',line)
            try:
                num = lst[0].strip()
                name = lst[1].strip()
                dgobj.set_num(num)
                dgobj.set_name(name)
                asmdg_objlst.append(dgobj)
            except:
                asmdg_objlst.append(dgobj)
                
        #2
        #求asmdg state
        asm_dgstatelst = attr_valuelst_dic[attribute_arr[2]][2:-1]
        #去掉不是有效值的行
        templst = []
        for line in  asm_dgstatelst:
            if ('GROUP_NUMBER'.lower() in line.lower()) or ('NAME'.lower() in line.lower()):
                continue
            elif ('---' in line):
                continue
            templst.append(line)
        asm_dgstatelst = templst
        for line in asm_dgstatelst:
            lst = re.split('\\s+',line)
            if len(lst)>=2:
                gpnum = lst[0].strip()
                gpstate = lst[1].strip()
            else:
                gpnum = 'NA'
                gpstate = 'NA'
            for obj in asmdg_objlst:
                if gpnum == obj.get_num():
                    obj.set_state(gpstate)
        #3
        #求asmdg capacity
        asm_dgcaplst = attr_valuelst_dic[attribute_arr[3]][2:-1]
        #去掉不是有效值的行
        templst = []
        for line in  asm_dgcaplst:
            if ('GROUP_NUMBER'.lower() in line.lower()) or ('NAME'.lower() in line.lower()):
                continue
            elif ('---' in line):
                continue
            templst.append(line)
        asm_dgcaplst = templst
        for line in asm_dgcaplst:
            lst = re.split('\\s+',line)
            if len(lst)>=2:
                num = lst[0].strip()
                cap = lst[1].strip()
            else:
                num = 'NA'
                num = 'NA'
            cap = str(round(float(cap)/1024.0,2))+ ' GB'
            for obj in asmdg_objlst:
                if num == obj.get_num():
                    obj.set_totalmb(cap)
    #4
    asmdisklst = attr_valuelst_dic[attribute_arr[-2]][2:-1]
    asmdisk_objlst = []
    asmdisk_objlst = get_asmdisk_lst(asmdisklst)
    #求value_lst
    for asmdisk in asmdisk_objlst:
        for diskgp in asmdg_objlst:
            if asmdisk.get_groupnum() ==diskgp.get_num():
                value_lst.append(diskgp.get_num())
                value_lst.append(diskgp.get_name())
                value_lst.append(diskgp.get_state())
                value_lst.append(diskgp.get_totalmb())
                value_lst.append(asmdisk.get_asmname()) 
                value_lst.append(asmdisk.get_asmpath())
        
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#求asmdisk集合
def get_asmdisk_lst(asmdisklst):
    templst = []
    asmdisk_objlst = []
    #去掉不是有效值的行
    for line in asmdisklst:
        if 'PATH' in line:
            continue
        elif ('GROUP_NUMBER' in line) or ('NAME' in line):
            continue
        elif ('---' in line):
            continue
        templst.append(line)
    asmdisklst = templst
    temp = ' '.join(asmdisklst)
    asmdisk_value_lst = re.split('\\s+',temp)
    value_len = len(asmdisk_value_lst)
    count = value_len / 3
    if 0 == value_len%3:
        c = 0
        while c<count:
            asmdisk = Asm_Disk()
            asmdisk.set_groupnum(asmdisk_value_lst[3*c])
            asmdisk.set_asmname(asmdisk_value_lst[3*c+1])
            asmdisk.set_asmpath(asmdisk_value_lst[3*c+2])
            asmdisk_objlst.append(asmdisk)
            c = c+1
    else:
        asmdisk = Asm_Disk()
        asmdisk_objlst.append(asmdisk)
    return asmdisk_objlst

    
#判断字符串 是否包含于列表中的某项
def is_belong_lst(value,templst):
    result = False
    for line in templst:
        if value.lower().strip() in line.lower():
            result = True 
    return result 

#检查key_lst
def check_keylst(key_lst,attribute_arr):
    if not (len(key_lst) == len(attribute_arr)):
        raise Exception("key lst Error")


#功能说明：范围属性名和对应回文组成的列表
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

class Disk_Group:
    __group_num = 'NA'
    __name = 'NA'
    __state = 'NA'
    __total_mb = 'NA'
    def set_num(self,num):
        self.__group_num = num
    def set_name(self,name):
        self.__name = name
    def set_state(self,state):
        self.__state = state
    def set_totalmb(self,mb):
        self.__total_mb = mb 
    def get_num(self):
        return self.__group_num
    def get_name(self):
        return self.__name
    def get_state(self):
        return self.__state
    def get_totalmb(self):
        return self.__total_mb

class Asm_Disk:
    __groupnum = 'NA'
    __asmname = 'NA'
    __asmpath = 'NA'
    def set_groupnum(self,num):
        self.__groupnum = num
    def set_asmname(self,name):
        self.__asmname = name
    def set_asmpath(self,path):
        self.__asmpath = path
    def get_groupnum(self):
        return self.__groupnum
    def get_asmname(self):
        return self.__asmname
    def get_asmpath(self):
        return self.__asmpath

