# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context
global vg_lst_value_lst
global lv_lst_value_lst

#对应excel中的属性字段
key_lst = ["vg_name","vg_size","lv_name","lv_size","lv_status"]

#获取Linux主机集群 之lvm/vxvm信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #模糊查询 
    attr_similarvaluelst_dic = get_attrsimilarvalue_dic(context,attrcom_dic)
    
    #获取attribute ,value_lst
    for key in key_lst:
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    if len(key_lst) == len(attribute_arr):
        pass
    else:
        raise Exception('not match, key lst and attribute_arr')
    
    #vgname lv_name lv_status
    lvmlst_first= attr_similarvaluelst_dic[attribute_arr[0]]
    lvmbean_lst = get_lvmbeanlst(lvmlst_first)
    #vgsize
    vglst = attr_similarvaluelst_dic[attribute_arr[1]]
    vgbean_lst = get_vgbeanlst(vglst)
    for lvm in lvmbean_lst:
        for vg in vgbean_lst:
            lvm_vgname = lvm.get_vgname()
            vg_vgname = vg.get_vgname()
            if lvm_vgname.lower().strip() == vg_vgname.lower():
                lvm.set_vgsize(vg.get_vgsize())
    #lvsize 
    lvsize_lst = attr_similarvaluelst_dic[attribute_arr[-2]]
    lvsizebean_lst = get_lvsizebean_lst(lvsize_lst)
    for lvm in lvmbean_lst:
        for lvsize in lvsizebean_lst:
            if lvm.get_lvname().strip().lower() in lvsize.get_name().lower():
                lvm.set_lvsize(lvsize.get_size())
    
    #获取json结果字符串
    for lvm in lvmbean_lst:
        value_lst.append(lvm.get_vgname())
        value_lst.append(lvm.get_vgsize())
        value_lst.append(lvm.get_lvname())

        value_lst.append(lvm.get_lvsize())
        value_lst.append(lvm.get_lvstatus())
     
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context, style, 'result', result)
    return context


#功能说明：返回属性名与回文列表组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


#功能说明：返回模糊命令的回文
def get_attrsimilarvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = similarcomdsbyfile_aixlvm(all_comds_lst,path)
    return get_attrsimilar_lst_dic(attrcom_dic,all_comds_byfile,path)


def similarcomdsbyfile_aixlvm(comds,path):
    all_comds_byfile = []
    file_handler = open(path,'r')
    for line in file_handler:
        for comd in comds:
            if comd.lower() in line.lower():
                all_comds_byfile.append(line.strip())
            else:
                continue
    file_handler.close()
    return all_comds_byfile

#vgname lv_name lv_status
def get_lvmbeanlst(templst):
    lvmbean_lst = []
    if 0 == len(templst):
        lvmbean = Lvm_Entity()
        lvmbean_lst.append(lvmbean)
        return lvmbean_lst
    lvmblock_lst = get_block_lst(templst)
    for block in lvmblock_lst:
        vgname = 'NA'
        blocklst = block[1:-1]
        for i,line in enumerate(blocklst):
            if (('lsvg' in line.lower()) or ('-' in line.lower())):
                vgname = blocklst[i+1][0:-1].strip()
                break
        #lvname lvstatus 值对应lst
        lvlst = []
        for j,vline in enumerate(blocklst):
            pass
            if (('lv' in vline.lower()) and ('type' in vline.lower()) and ('name' in vline.lower())):
                lvlst = blocklst[j+1:-1]
                break

        for k,lvline in enumerate(lvlst):
            lst = re.split('\\s+',lvline.strip())
            if len(lst) >= 7:
                lvbean = Lvm_Entity()
                lvbean.set_vgname(vgname)
                lvname = lst[0].strip()[0:].strip()
                lvbean.set_lvname(lvname)
                lvbean.set_lvstatus(lst[-2].strip())
                lvmbean_lst.append(lvbean)
    return lvmbean_lst
        
def get_vgbeanlst(templst):
    vgbean_lst = []
    if 0 == len(templst):
        vg = Vg_Entity()
        vgbean_lst.append(vg)
        return vgbean_lst
    vgblock_lst = get_block_lst(templst)
    for block in vgblock_lst:
        block = block[1:-1]
        vgname = 'NA'
        ppsize = 0.0 
        totalpps = 0.0 
        vg = Vg_Entity()
        for i,line in enumerate(block):
            if (('volume' in line.lower()) and ('group' in line.lower())):
                temp = re.split(':',line)[1].strip()
                vgname = re.split('\\s+',temp)[0].strip()
                vg.set_vgname(vgname)
                continue
            if (('pp' in line.lower()) and ('size' in line.lower())):
                lst = re.split(':',line)
                temp = lst[-1].strip()
                ppsize = re.split('\\s+',temp)[0].strip()
                try:
                    ppsize = float(ppsize)
                except:
                    raise('Value Error')
                continue
            if (('total' in line.lower()) and ('pps' in line.lower())):
                lst = re.split(':',line) 
                temp = lst[-1].strip()
                totalpps = re.split('\\s+',temp)[0].strip()
                try:
                    totalpps = float(totalpps)
                except:
                    raise('Value Error')
                vgsize = ppsize*totalpps/1024.0
                vgsize = round(vgsize,2)
                vgsize = str(vgsize)+ ' GB'
                vg.set_vgsize(vgsize)
                vgbean_lst.append(vg)
                break
    return vgbean_lst

#获取lvsize 
def get_lvsizebean_lst(templst):
    lvsizebean_lst = []
    lvsizeblock_lst = get_block_lst(templst)
    if 0 == len(templst):
        lvsize = Lv_Size()
        lvsizebean_lst.append(lvsize)
        return lvsizebean_lst
    for block in lvsizeblock_lst:
        lvsize = Lv_Size()
        ppsize = 0.0 
        pps = 0.0
        for line in block:
            if 'cmd_display_logic_volune_lslv_lvname_' in line.lower():
                lst = line.split('-')
                lvname = lst[-1].strip()
                lvsize.set_name(lvname)
                continue
            if (('pp' in line.lower()) and ('size' in line.lower())):
                lst = line.split(':')
                temp = lst[-1].strip()
                ppsizelst = re.split('\\s+',temp)
                ppsizetemp = ppsizelst[0].strip()
                try:
                    ppsize = float(ppsizetemp)
                except:
                    ppsize = float(0)
                continue
            if (('pps' in line.lower()) and ('lps' in line.lower())):
                lst = line.split(':')
                temp = lst[-1].strip()
                try:
                    pps = float(temp)
                except:
                    pps = float(0)
                
                size = ppsize*pps/1024
                size = round(size,2)
                size = str(size)+" GB"
                lvsize.set_size(size)
                lvsizebean_lst.append(lvsize)
                continue
    return lvsizebean_lst
        
#功能说明：返回单个命令回文块组成的列表
def get_block_lst(tempList):
    index = 0 
    txtList = []
    resultlst = []
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i+1])
            index = i+1 
    for lst in txtList:
        #去掉空的项
        lst = checktempList(lst)
        resultlst.append(lst)
    return resultlst  


class Lvm_Entity:
    __vgname = 'NA'
    __vgsize = 'NA'
    __lvname = 'NA'
    __lvsize = 'NA'
    __lvstatus = 'NA'
    def get_vgname(self):
        return self.__vgname
    def get_vgsize(self):
        return self.__vgsize
    def get_lvname(self):
        return self.__lvname
    def get_lvsize(self):
        return self.__lvsize
    def get_lvstatus(self):
        return self.__lvstatus
    def set_vgname(self,vgname):
        self.__vgname = vgname
    def set_vgsize(self,vgsize):
        self.__vgsize = vgsize
    def set_lvname(self,lvname):
        self.__lvname = lvname
    def set_lvsize(self,lvsize):
        self.__lvsize = lvsize
    def set_lvstatus(self,lvstatus):
        self.__lvstatus  = lvstatus

class Vg_Entity:
    __vgname = 'NA'
    __vgsize = 'NA'
    
    def get_vgname(self):
        return self.__vgname
    def get_vgsize(self):
        return self.__vgsize
    def set_vgname(self,vgname):
        self.__vgname = vgname
    def set_vgsize(self,vgsize):
        self.__vgsize = vgsize
        
class Lv_Size:
    __name = 'NA'
    __size = 'NA'
    def set_name(self,name):
        self.__name = name
    def set_size(self,size):
        self.__size = size
    def get_name(self):
        return self.__name
    def get_size(self):
        return self.__size
