# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    attrvalue_dicexact = get_attrvalue_dicexact(context,attrcom_dic)
    device_value_lst = getValueFMap(attr_valuelst_dic, style, 'device')
    device_lunwwn_lst = getValueFMap(attrvalue_dicexact, style, 'lunwwn')

    diskObjList = []
    diskObjList = get_device_cap_lst(device_value_lst)
    get_LUNWWN(device_lunwwn_lst,diskObjList)
    
    for diskobj in diskObjList:
        value_lst.append(diskobj.get_device())
        value_lst.append(diskobj.get_vendor())
        value_lst.append(diskobj.get_capacity())
        value_lst.append(diskobj.get_wwn())
        value_lst.append(diskobj.get_pvname())
        value_lst.append(diskobj.get_vgname())
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context

#功能说明：返回属性名与对应回文列表
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_similarcomds_byfile(all_comds_lst,path)
    return get_attrsimilar_lst_dic(attrcom_dic,all_comds_byfile,path)


def get_attrvalue_dicexact(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)


def get_device_cap_lst(tempList):
    diskObjList = []
    if 0 == len(tempList):
        diskObj = Disk_Entity()
        diskObjList.append(diskObj)
        return diskObjList
    txtList = []
    index = 0
    for i,line in enumerate(tempList):
        if divide in line:
            txtList.append(tempList[index:i])
            index = i + 1
    
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    
    resultTxt = []
    
    for txtBlock in txtList:
        flag = True
        for line in txtBlock:
            if failStr.lower() in line.lower():
                flag = False
                break
        if flag:
            resultTxt.append(txtBlock)
            
    if len(resultTxt) == 0:
        diskObj = Disk_Entity()
        diskObjList.append(diskObj)
        return diskObjList
    
    for singleList in resultTxt:
        for line in singleList:
            if 'scsi' in line.lower() and 'describe' in line.lower():
                tempArr = re.split('\\s+', line)
                diskObj = Disk_Entity()
                tempArr[3] = tempArr[3].replace(':','')
                diskObj.set_device(tempArr[3])
            if 'vendor' in line.lower():
                tempArr = line.split(':')
                diskObj.set_vendor(tempArr[1])
            if 'size' in line.lower():
                tempArr = line.split(':')
                tempArr[1] = tempArr[1].replace('Kbytes','').strip()
                diskObj.set_capacity(str(round(float(tempArr[1])/1024.0/1024.0,2))+'GB')
                diskObjList.append(diskObj)
    return diskObjList
                
#功能说明：返回LUNWWN
def get_LUNWWN(tempList,diskList):
    
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        return
    
    for line in tempList:
        if failStr.lower() in line.lower():
            return
    
    if len(tempList) > 3:
        tempList = tempList[2:-1]
        flag = False
        for line in tempList:
            if ('lun wwn' in line.lower()) and ('disk' in line.lower()):
                tempList = tempList[2:-1]
                break
    
        for diskObj in diskList:
            for line in tempList:
                tempArr = []
                tempArr = line.split(':')
                if diskObj.get_device() == tempArr[0]:
                    diskObj.set_wwn(tempArr[1])
                    break
        
#功能说明：返回PV name 
def get_pvvgname(tempList,diskList):
    #{pv_name:'',vg_name:''}
    failStr = 'TOOLKIT_EXE_CMD_FAILED'
    if 0 == len(tempList):
        return
    
    for line in tempList:
        if failStr.lower() in line.lower():
            return
    pv_map_lst =[]
    for diskObj in diskList:
        for line in tempList:
            if ('pv' in line.lower()) and('name' in line.lower()):
                pvname = line.split(' ')[-1].strip()
                diskObj.set_pvname(pvname)
            elif ('vg' in line.lower()) and('name' in line.lower()):
                vgname = line.split(' ')[-1].strip()
                diskObj.set_vgname(vgname)

     

def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_device(tempList)
    elif key == key_lst[1]:
        return get_Vendor(tempList)
    elif key == key_lst[2]:
        return get_Capacity(tempList)
    elif key == key_lst[3]:
        return get_LUNWWN(tempList)
    elif key == key_lst[4]:
        return get_PV_name(tempList)
    elif key == key_lst[5]:
        return get_VG_name(tempList)
    else:
        return "Key Error"
    

class Disk_Entity:
    __disk_device = 'NA'
    __disk_vendor = 'NA'
    __disk_capacity = 'NA'
    __disk_wwn = 'NA'
    __disk_pvname = 'NA'
    __disk_vgname = 'NA'
    def get_device(self):
        return self.__disk_device
    def get_vendor(self):
        return self.__disk_vendor
    def get_capacity(self):
        return self.__disk_capacity
    def get_wwn(self):
        return self.__disk_wwn
    def get_pvname(self):
        return self.__disk_pvname
    def get_vgname(self):
        return self.__disk_vgname
    def set_device(self,device):
        self.__disk_device = device
    def set_vendor(self,vendor):
        self.__disk_vendor = vendor
    def set_capacity(self,cap):
        self.__disk_capacity = cap
    def set_wwn(self,wwn):
        self.__disk_wwn = wwn
    def set_pvname(self,pvname):
        self.__disk_pvname = pvname
    def set_vgname(self,vgname):
        self.__disk_vgname = vgname
