# --*-- coding:utf-8 --*--
import sys
import os
import re
reload(sys)
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import getSameCommandsHbaRetFromTxt
'''
   1、执行命令： esxcli storage core adapter list |grep -i "Fibre Channel"
   2、提取状态是linkup的端口的wwpn，如以下回文（由于有时候linkup状态的回文并不是link-up开头，所以脚本中配置up开头）
   vmhba5    lpfc          link-up     fc.20000090fa92bbe4:10000090fa92bbe4   xxx  Emulex LPe16000 16Gb PCIe Fibre Channel Adapter
        则  wwpn=10000090fa92bbe4。
'''
#获取hba卡数量
def execute(context):
    #命令描述
    CMD_DESC_WWPN = "cmd_display_hba_wwpns"
    UP = 'up'

    #回文列表
    wwpn_lst = []
    wwpn_clean = []
    result = ""

    #获取回文
    wwpn_lst = getSameCommandsHbaRetFromTxt(context, [CMD_DESC_WWPN])[0]
    #过滤
    for wwpnline in wwpn_lst:
        if ("Fibre" in wwpnline) and ("Channel" in wwpnline) and ("esxcli" not in wwpnline) and ("storage" not in wwpnline):
            wwpn_clean.append(wwpnline)
    wwpn_lst = wwpn_clean


    for line in wwpn_lst:
        lst = re.split('\s\s+', line)
        if UP in lst[2]:
            wwpn = re.split(':', lst[3])[-1].strip()
            result = result + wwpn + ';'
    result = result[0:-1]
    context["result"]=result
    return context
