# coding=utf-8
__author__ = '******'
# 获取hp-ux主机的虚拟化信息
import re
CLI = None
LANGUAGE = None
CHECK_FAIL          =       0
CHECK_PASS          =       1
cmd_info_id = ["cmd_info_virtual_hpvmstatus"      ,
			   "cmd_info_virtual_ioscan"          ,
			   "cmd_info_virtual_ioscan_func_disk",
			   "cmd_info_virtual_parstatus"       ,
			   "cmd_info_virtual_ioscan_fnk"      ,
			   "cmd_info_virtual_vparstatus"      ,
			   "cmd_info_virtual_vparstatus_v"    ,
			   "cmd_info_virtual_vparstatus_p"    ,
			   "cmd_info_virtual_swlist_par"      ,
			   "cmd_info_virtual_swlist_ignite"   ,
			   "cmd_info_virtual_vparstatus_m"    ,
			   "cmd_info_virtual_parstatus_v_p"   ,
			   "cmd_info_virtual_setboot_v"       ]
			
cmd_info_desc = ["hpvmstatus",
			     "ioscan",
			     "ioscan -funC disk",
			     "parstatus",
			     "ioscan -fnk",
			     "vparstatus",
			     "vparstatus -v",
			     "vparstatus -p ",
			     "swlist |grep -i par",
			     "swlist -l bundle |grep Ignite",
			     "vparstatus -m",
			     "parstatus -V -p 0",
			     "setboot -v"]
			
cmd_info_vpar_list = "vparstatus -v|grep Name|awk '{print $2}'"


def execute(context):
    """
    Function name      : execute
    Function describe  : 外部接入
    Input              : context
    Return             : cmd display
    """
    # 给全局变量赋初始值，按照要求传递上下文进去。
    global CLI
    CLI = context.get("SSH")
    global LANGUAGE
    LANGUAGE = context.get("lang")
    cmd_display = context.get("ret_map")
    return check_and_get_result(cmd_execute(cmd_display, CLI, LANGUAGE))


# 取中间一个有效值
def check_and_get_result((fun_flag, result, fun_err_msg)):
    """
    :rtype : object
    """
    return result


def cmd_execute(cmd_display, CLI, LANGUAGE):
    fun_flag = CHECK_FAIL
    fun_err_msg = ''
    vpar_list = (CLI.execCmdHasLog(cmd_info_vpar_list)).splitlines()
    for rg in range(len(cmd_info_id)):
        if cmd_info_id[rg]=="cmd_info_virtual_vparstatus_p":
            for vpar in vpar_list[1:]:
            	if vpar.find('vparstatus') >= 0:
            		continue
                cmd_display_temp=CLI.execCmdHasLogTimout(cmd_info_desc[rg] + vpar + " -v", 60)
            	cmd_display.put("cmd_display" + (cmd_info_id[rg])[8:] + "_" + vpar + "_v", cmd_display_temp)
                if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                    if "en"==LANGUAGE:
                        fun_err_msg        +=cmd_info_desc[rg] + vpar + " -v" + ":\texecute failed\r\n"
                    else:
                        fun_err_msg        +=cmd_info_desc[rg] + vpar + " -v" + u":\t执行失败\r\n"
                else:
                    if "en"==LANGUAGE:
    	                fun_err_msg        +=cmd_info_desc[rg] + vpar + " -v" + ":\texecute success\r\n"
    	            else:
    	                fun_err_msg        +=cmd_info_desc[rg] + vpar + " -v" + u":\t执行成功\r\n"
        else:
            cmd_display_temp = CLI.execCmdHasLogTimout(cmd_info_desc[rg],60)
            cmd_display.put("cmd_display"+(cmd_info_id[rg])[8:], cmd_display_temp)
            if None == cmd_display_temp or '' == cmd_display_temp or cmd_display_temp.find('TOOLKIT_SEND_CMD_TIME_OUT') > 0 or cmd_display_temp.find('TOOLKIT_EXE_CMD_FAILED') > 0:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute failed\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行失败\r\n"
            else:
                if "en"==LANGUAGE:
                    fun_err_msg        +=cmd_info_desc[rg] + ":\texecute success\r\n"
                else:
                    fun_err_msg        +=cmd_info_desc[rg] + u":\t执行成功\r\n"
    cmd_display.put("err_msg", fun_err_msg)
    fun_flag = CHECK_PASS
    return fun_flag, cmd_display, fun_err_msg