# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    addValueToMap(context,style,'command',command)
    #属性名与对应命令组成的列表的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute_arr ,value_lst
    for key in key_lst:
        for att in attr_valuelst_dic.keys():
            if key in att.lower():
                attribute_arr.append(att)
    #求device  capcity
    disk_obj_lst = []
    try:
        devicetemp_lst = attr_valuelst_dic[attribute_arr[0]]
    except:
        devicetemp_lst = []
    for temp in devicetemp_lst:
        if ('disk' in temp.lower()) and (',' in temp.lower()):
            device_obj = Disk_Entity()
            device = temp.split(':')[0][4:].strip()
            device_obj.set_device(device)
            
            cap = temp.replace(device,'')
            cap = cap.lower().replace('disk','')
            cap = cap.split(',')[0]
            cap = cap.replace(':','').strip()
            cap = cap.replace('gb','GB')
            device_obj.set_capacity(cap)
            disk_obj_lst.append(device_obj)
            continue
    #求vendor
    vendortemp_lst = []
    try:
        vendortemp_lst = attr_valuelst_dic[attribute_arr[1]]
    except:
        vendortemp_lst = []
   
    for d in  disk_obj_lst:
        for vendortemp in vendortemp_lst:
            if d.get_device() in vendortemp:
                templst = re.split('\\s+',vendortemp)
                vd = templst[2].strip()
                d.set_vendor(vd)
                continue
    #求lun
    try:
        luntemp_lst = attr_valuelst_dic[attribute_arr[3]]
    except:
        luntemp_lst = []
    
    for d in disk_obj_lst:
        for luntemp in luntemp_lst:
            device =  d.get_device().split('/')[-1].strip()
            if device in luntemp.lower():
                lun_lst = re.split('\\s+',luntemp)
                try:
                    lunwwn = lun_lst[3].strip()
                except:
                    lunwwn = 'NA' 
                d.set_wwn(lunwwn)
    #求value_lst
    for temp_obj in disk_obj_lst:
        value_lst.append(temp_obj.get_device())
        value_lst.append(temp_obj.get_vendor())
        value_lst.append(temp_obj.get_capacity())
        value_lst.append(temp_obj.get_wwn())
        value_lst.append(temp_obj.get_pvname())
        value_lst.append(temp_obj.get_vgname())
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文列表
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)
  

class Disk_Entity:
    __disk_device = 'NA'
    __disk_vendor = 'NA'
    __disk_capacity = 'NA'
    __disk_wwn = 'NA'
    __disk_pvname = 'NA'
    __disk_vgname = 'NA'
    def get_device(self):
        return self.__disk_device
    def get_vendor(self):
        return self.__disk_vendor
    def get_capacity(self):
        return self.__disk_capacity
    def get_wwn(self):
        return self.__disk_wwn
    def get_pvname(self):
        return self.__disk_pvname
    def get_vgname(self):
        return self.__disk_vgname
    def set_device(self,device):
        self.__disk_device = device
    def set_vendor(self,vendor):
        self.__disk_vendor = vendor
    def set_capacity(self,cap):
        self.__disk_capacity = cap
    def set_wwn(self,wwn):
        self.__disk_wwn
    def set_pvname(self,pvname):
        self.__disk_pvname = pvname
    def set_vgname(self,vgname):
        self.__disk_vgname = vgname
