# --*-- coding:utf-8 --*--
import sys
import os
import re
import traceback

reload(sys)
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

OsVersion = 'cmd_display_os_basic_vcfg'

#获取OS信息
def execute(context):
    #获取回文
    global LOG
    LOG = context.get("Logger")
    tempList = getSingleOrMoreCommandRetFromTxt(context, OsVersion, False)
    result = getOsName(tempList)

    context["result"]=result
    return context


def getOsName(callList):
    version = ''
    result = 'NA'
    for idx,line in enumerate(callList):
        if 'GalaxVersion.cfg'.lower() in line.lower():
            try:
                version = callList[idx+1].strip()
                version = re.findall(r'V\d{3}R\d{3}C\d{2}', version)
                result = "FusionCompute " + ''.join(version)
            except:
                LOG.error("GalaxVersion not found." + unicode(traceback.format_exc()))
    return result
