# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context
global vg_lst_value_lst
global lv_lst_value_lst

#对应excel中的属性字段
key_lst = ["vg_name","vg_size","lv_name","lv_size","lv_status"]

#获取Linux主机集群 lvm /vxvm信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)

    vg_lst_value_lst = []
    lv_lst_value_lst= []
    #获取vg，lv 信息所对应回文的列表
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
                if key_lst[0] in attr.lower():
                    #获得vg name　lst
                    vg_lst_value_lst =  getValueFMap(attr_valuelst_dic, style, attr)
                if key_lst[2] in attr.lower():
                    #获得lv lst
                    lv_lst_value_lst = getValueFMap(attr_valuelst_dic, style, attr)

    vg_lst = get_vg_lst(vg_lst_value_lst)
    lv_lst = get_lv_lst(lv_lst_value_lst)
                    
   #VG name    VG size    LV name    LV size    LV status
    len_lv_lst = len(lv_lst)
    for i in range(len_lv_lst):
        vg_name = getValueFMap(lv_lst[i], style, 'lv_vgname')
        value_lst.append(vg_name)
        vg_size = ""
        #根据 vg name 求 vg size
        for j in range(len(vg_lst)):
            if vg_name.strip() ==  getValueFMap(vg_lst[j], style, 'vg_name'):
                vg_size =  getValueFMap(vg_lst[j], style, 'vg_size')
        value_lst.append(vg_size)
        lv_name = getValueFMap(lv_lst[i], style, 'lv_name')
        value_lst.append(lv_name)
        lv_size = getValueFMap(lv_lst[i], style, 'lv_size')
        value_lst.append(lv_size)
        lv_status = getValueFMap(lv_lst[i], style, 'lv_status')
        value_lst.append(lv_status)
     
    #获取json结果字符串 
    value_lst = []
    value_lst = ['NA','NA','NA','NA','NA']
    
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    
    addValueToMap(context, style, 'result', result)
    return context



#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)
 

#功能说明：返回vg对象列表
def get_vg_lst(tempList):
    result = ""
    vg_lst = []
    for line in tempList:
        if ('vg' in line.lower()) and ('name' in line.lower()):
            vg_map = {}
            result = line.lower()
            result = result.split(' ')[-1].strip()
            addValueToMap(vg_map, style, 'vg_name', result)
            continue
        elif ('vg' in line.lower()) and ('size' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-2].strip()
            addValueToMap(vg_map, style, 'vg_size', result)
            vg_lst.append(vg_map)
            continue
    return vg_lst
        

#功能说明：返回lv对象列表
def get_lv_lst(tempList):
    result = ""
    lv_map_lst = []
    for line in tempList:
        if ('lv' in line.lower()) and ('name' in line.lower()):
            lv_map = {}
            result = line.lower()
            result = result.split(' ')[-1].strip()
            addValueToMap(lv_map, style, 'lv_name', result)
            continue
        elif ('lv' in line.lower()) and ('size' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-2].strip()
            addValueToMap(lv_map, style, 'lv_size', result)
            continue
        elif ('vg' in line.lower()) and ('name' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-1].strip()
            addValueToMap(lv_map, style, 'lv_vgname', result)
            continue
        elif ('lv' in line.lower()) and ('status' in line.lower()):
            result = line.lower()
            result = result.split(' ')[-1].strip()
            addValueToMap(lv_map, style, 'lv_status', result)
            lv_map_lst.append(lv_map)
    return lv_map_lst


def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_servermodel(tempList)
    else:
        return "Key Error"
 
     