# --*-- coding:utf-8 --*--
import sys 
import os
import re
from cmd import Cmd
reload(sys) 
sys.setdefaultencoding('utf-8')
path = os.path.dirname(os.path.abspath(__file__))
path = os.path.join(path, "..\\..\\..")
sys.path.append(path)
from common.contentParse import *

global key_lst  #对应Excel中属性列表
global attribute_arr #从传入的命令中获取的属性列表 
global  value_lst
global context

#对应excel中的属性字段
key_lst  = [
                     'device', 
                     'vendor',
                     'capacity',
                     'lunwwn',
                     'pv_name',
                     'vg_name'
            ]

#获取Linux主机集群 Server信息
def execute(context):
    #获取回文
    #start
    path = getValueFMap(context,style,'path')
    command = getValueFMap(context,style,'command').strip()
    attribute_arr = []
    value_lst = []
    if ';'== command[-1]:
        command =command[0:-1]
    addValueToMap(context,style,'command',command)
    #属性名与对应命令列表组成的字典
    attrcom_dic = get_attrcom_dic(context)
    #对应execel属性名
    json_attr_name = get_jsonarr_name(attrcom_dic)
    #属性名与对应回文组成的字典
    attr_valuelst_dic = get_attrvalue_dic(context,attrcom_dic)
    #获取attribute ,value_lst
    
    device_value_lst =getValueFMap(attr_valuelst_dic, style, 'device')
    device_cap_lst =  get_device_cap_lst(device_value_lst)
    
    device_vendor_lst = getValueFMap(attr_valuelst_dic, style, 'vendor')
    device_lunwwn_lst = getValueFMap(attr_valuelst_dic, style, 'lunwwn')
    device_pv_lst = getValueFMap(attr_valuelst_dic, style, 'pv_name')
    device_vg_lst = getValueFMap(attr_valuelst_dic, style, 'vg_name')
    
    for device in device_cap_lst:
        value_lst.append(getValueFMap(device, style, 'device'))
        value_lst.append(get_Vendor(device_vendor_lst))
        value_lst.append(getValueFMap(device, style, 'capacity'))
        
        value_lst.append(get_LUNWWN(device_lunwwn_lst))
        
        pv_map_lst = get_pvmap_lst(device_pv_lst)
        if 1 == len(pv_map_lst):
            pv_name =  getValueFMap(pv_map_lst[0], style, 'pv_name')
            value_lst.append(pv_name)
        value_lst.append(get_VG_name(device_vg_lst)[0])

    
    for key in key_lst:
        tempList = []
        for attr in attr_valuelst_dic.keys():
            if key.lower().strip() in attr.lower():
                attribute_arr.append(attr)
    #获取json结果字符串                
    result = get_jsonstr(json_attr_name,attribute_arr, value_lst)
    addValueToMap(context,style,'result',result)
    return context


#功能说明：返回属性名与对应回文组成的字典
def get_attrvalue_dic(context,attrcom_dic):
    all_comds_lst = get_purecommands_lst(attrcom_dic)
    path = getValueFMap(context,style,'path')
    all_comds_byfile = get_comdslst_byfile(all_comds_lst,path)
    
    return get_attrlst_dic(attrcom_dic,all_comds_byfile,path)

#功能说明：返回Device
def get_device_cap_lst(tempList):
    device_map = {} #{device:容量(GB)}
    device_lst = []#[{},{}]
    
    for line in tempList:
        device = ""
        cap = ""
        temp = ""
        if ('disk' in line.lower()) and (',' in line):
            temp = line.lower()
            device = temp.split(':')[0].replace('disk','').strip()
            cap = temp.split(':')[1].split(',')[0].strip()
            if 'gb' in cap:
                cap = cap.replace('gb','').strip()
                cap = cap.strip()
            elif 'mb' in cap:
                cap = cap.replace('mb','').strip()
                cap = str(round(float(cap)/1024.0,2))
            addValueToMap(device_map,style,'device',device)
            addValueToMap(device_map,style,'capacity',cap)
            device_lst.append(device_map)
            device_map ={}
    return device_lst
    

#功能说明：返回Vendor
def get_Vendor(tempList):
    result = ""
    return "NA"

#功能说明：返回capacity
def get_Capacity(tempList):
    return "512GB"
#功能说明：返回LUNWWN
def get_LUNWWN(tempList):
    return "NA"

#功能说明：返回PV name 
def get_pvmap_lst(tempList):
    #{pv_name:'',vg_name:''}
    pv_map_lst =[]
    for line in tempList:
        if ('pv' in line.lower()) and('name' in line.lower()):
            pv_map = {}
            pvname = line.split(' ')[-1].strip()
            addValueToMap(pv_map,style,'pv_name',pvname)
            continue
        elif ('vg' in line.lower()) and('name' in line.lower()):
            vgname = line.split(' ')[-1].strip()
            addValueToMap(pv_map,style,'vg_name',vgname)
            pv_map_lst.append(pv_map)
    return pv_map_lst
    
    
#功能说明：返回Vendor
def get_VG_name(tempList):
    vg_name_lst = []
    for line in tempList:
        if ('vg' in line.lower()) and ('name' in line.lower()):
            vg_name_lst.append(line.split(' ')[-1].strip()) 
    return vg_name_lst   

def get_value_bykey(tempList,key):
    if key == key_lst[0]:
        return get_device(tempList)
    elif key == key_lst[1]:
        return get_Vendor(tempList)
    elif key == key_lst[2]:
        return get_Capacity(tempList)
    elif key == key_lst[3]:
        return get_LUNWWN(tempList)
    elif key == key_lst[4]:
        return get_PV_name(tempList)
    elif key == key_lst[5]:
        return get_VG_name(tempList)
    else:
        return "Key Error"
